******------------------------------------------------------------------
*     This program performs stochastic simulations for bayesian 
*     learning based on reading instead of experiments.
*     The learner must choose from two theories and the possibility
*     that a given article is wrong is included in the analysis.
******------------------------------------------------------------------
      PROGRAM BAYES
******------------------------------------------------------------------
*     Double precision everything.
******------------------------------------------------------------------
      implicit double precision (a-h,o-z)
******------------------------------------------------------------------
*     Include files with parameters and common blocks.
******------------------------------------------------------------------
      include 'fp_def.f'
      include 'cb_all.f'
      nseed=-978513139
******------------------------------------------------------------------
*     Get the input data
******------------------------------------------------------------------
      do iloop=1,1000
         call input
******------------------------------------------------------------------
*     Initialize the population at t=0
******------------------------------------------------------------------
         call initialize
******------------------------------------------------------------------
*     Loop for the articles
******------------------------------------------------------------------
         iart=1
         do while(iart.le.ma)
            call article
            call update
            call avers
            if ((pave.ge.precision).or.(pave.le.(1.0d0-precision))) then
 200           open(unit=1,file='stop.dat'  
     *              ,access='append' ,iostat=ierr)
               if (ierr.ne.0) go to 200
               write(1,*) iart, pave, epav, epreal , epave, delave
               close(unit=1)
               iart=ma 
            end if
            iart=iart+1
         end do
******------------------------------------------------------------------
*     Write the results
******------------------------------------------------------------------
         call writeop
      end do
******------------------------------------------------------------------
*     End the Program
******------------------------------------------------------------------
      STOP
      END

