******------------------------------------------------------------------
*     This subroutine defines the discretized version of the priori
*     believes, based on the beta parameters.
******------------------------------------------------------------------
      SUBROUTINE INITIALIZE
******------------------------------------------------------------------
*     Double precision everything.
******------------------------------------------------------------------
      implicit double precision (a-h,o-z)
******------------------------------------------------------------------
*     Include files with parameters and common blocks.
******------------------------------------------------------------------
      include 'fp_def.f'
      include 'cb_all.f'
******------------------------------------------------------------------
*     Estimate beta parameters for priori distributions; ep and del
*     only, p is a discrete variable.
******------------------------------------------------------------------
      epa = (epav**2)*(1-epav)/((epstd**2)*(1+epav))
      epb = epa*(1-epav)/epav
      dela = (delav**2)*(1-delav)/((delstd**2)*(1+delav))
      delb = dela*(1-delav)/delav
******------------------------------------------------------------------
*     Initialize opinion field
******------------------------------------------------------------------
      sumphi=0.0d0
      do i=0,1
         do j=0,md
            do k=0,md
*               p=dfloat(i)/dfloat(md)
               p=dfloat(1-i)*(1-pav)+dfloat(i)*pav
               ep=dfloat(j)/dfloat(md)
               del=dfloat(k)/dfloat(md)
               phi(i,j,k)=p*(ep**epa)*((1-ep)**epb)
     *                    *(del**dela)*((1-del)**delb)
               sumphi=sumphi+phi(i,j,k)
            end do
         end do
      end do
******------------------------------------------------------------------
*     Normalize the opinion field.
******------------------------------------------------------------------
      sumphi=1.0d0/sumphi
      do i=0,1
         do j=0,md
            do k=0,md
               phi(i,j,k)=sumphi*phi(i,j,k)
            end do
         end do
      end do
      pave=0.0d0
      epave=0.0d0
      delave=0.0d0
      do i=0,1
         do j=0,md
            do k=0,md
               p=dfloat(i)
               eps=dble(j)/dfloat(md)
               del=dble(k)/dfloat(md)
               pave=pave+p*phi(i,j,k)
               epave=epave+eps*phi(i,j,k)
               delave=delave+del*phi(i,j,k)
            end do
         end do
      end do
******------------------------------------------------------------------
      return
      END
******------------------------------------------------------------------
