******------------------------------------------------------------------
*     This subroutine updates the opinions of the readers, using
*     Bayes theorem and including the possibility of deception.
******------------------------------------------------------------------
      SUBROUTINE UPDATE(istud,iread)
******------------------------------------------------------------------
*     Double precision everything.
******------------------------------------------------------------------
      implicit double precision (a-h,o-z)
******------------------------------------------------------------------
*     Include files with parameters and common blocks.
******------------------------------------------------------------------
      include 'fp_def.f'
      include 'cb_all.f'
******------------------------------------------------------------------
*     Local variables:
*     phinew = temporary storage for update opinion.
******------------------------------------------------------------------
      dimension phinew(0:md,0:md,0:md)
******------------------------------------------------------------------
*     Initialing local variables.
******------------------------------------------------------------------
      sumphinew=0.0d0
      do i=0,1
         do j=0,md
            do k=0,md
               phinew(i,j,k)=0.0d0
            end do
         end do
      end do
******------------------------------------------------------------------
*     Calculate the unnormalized posteriori.
******------------------------------------------------------------------
      do i=0,1
         do j=0,md
            do k=0,md
               p=dfloat(i)
               eps=dfloat(j)/dfloat(md)
               del=dfloat(k)/dfloat(md)
               if (iart.eq.0) then
                  blike=eps*del+(1-eps)*(p*alpha+(1-p)*(1-beta))
               else
                  blike=eps*(1-del)+(1-eps)*(p*(1-alpha)+(1-p)*beta)          
               end if
               phinew(i,j,k)=phi(i,j,k)*blike
               sumphinew=sumphinew+phinew(i,j,k)
            end do
         end do
      end do
******------------------------------------------------------------------
*     Normalize the posteriori
******------------------------------------------------------------------
      sumphinew=1.0d0/sumphinew
      do i=0,1
         do j=0,md
            do k=0,md
               phi(i,j,k)=sumphinew*phinew(i,j,k)
            end do
         end do
      end do
      return
      END
******------------------------------------------------------------------
